
package mobicomp.net;

import java.io.IOException;
import java.util.Collections;
import java.util.Observable;
import java.util.Observer;
import java.util.Vector;

import mobicomp.interfaces.MHMessage;

/**
 * TODO
 * 
 * @author Andreas Wetzel <andi@spamato.net>
 */
class RouteReplyHandler implements Observer
{
    private MHSocketImpl socket;

    public RouteReplyHandler( MHSocketImpl socket) {
        this.socket = socket;
    }

    public void update( Observable o, Object arg) {
    		MHMessage mhm = (MHMessage) arg;
    		if (mhm.getType() != MHMessage.TYPE_RREP) {
    			return;
    		}
    		
        if (mhm.getReceiver() == socket.getOwnAddress()) {
            // store route in the socket's routing table
            // but reverse it first
            Vector route = mhm.getRoute();
            Collections.reverse( route);
            socket.newRoute( mhm.getSender(), route);
        }
        else {
        		Vector route = mhm.getRoute();
        		int index = mhm.getRouteIndex();
        	
        		// get intermediate receiver from the message route
        		int relay = ((Integer)route.get( index)).intValue();
        		// check if we are the 'relay' station
        		if (relay == socket.getOwnAddress()) {
        			
        			// find next hop and submit message
        			int nexthop = ((Integer)route.get( index+1)).intValue();
        			mhm.setRouteIndex( index+1);
        			try {
        				socket.sendMHMessage( mhm, nexthop);
				} catch (IOException e) {
					e.printStackTrace();
				}
        		}
        }
    }
}
